<?php
/*------------------------------------------------------------------------------
     The contents of this file are subject to the Mozilla Public License
     Version 1.1 (the "License"); you may not use this file except in
     compliance with the License. You may obtain a copy of the License at
     http://www.mozilla.org/MPL/

     Software distributed under the License is distributed on an "AS IS"
     basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
     License for the specific language governing rights and limitations
     under the License.

     The Original Code is fun_up.php, released on 2003-03-31.

     The Initial Developer of the Original Code is The QuiX project.

     Alternatively, the contents of this file may be used under the terms
     of the GNU General Public License Version 2 or later (the "GPL"), in
     which case the provisions of the GPL are applicable instead of
     those above. If you wish to allow use of your version of this file only
     under the terms of the GPL and not to allow others to use
     your version of this file under the MPL, indicate your decision by
     deleting  the provisions above and replace  them with the notice and
     other provisions required by the GPL.  If you do not delete
     the provisions above, a recipient may use your version of this file
     under either the MPL or the GPL."
------------------------------------------------------------------------------*/
/*------------------------------------------------------------------------------
Author: The QuiX project
	quix@free.fr
	http://www.quix.tk
	http://quixplorer.sourceforge.net

Comment:
	QuiXplorer Version 2.3
	File-Upload Functions
	
	Have Fun...
------------------------------------------------------------------------------*/
//------------------------------------------------------------------------------
//include "./.include/common.php";

function check_password($dir,$item) {		// Path absoluto del fichero a comprobar password
	if(($GLOBALS["permissions"]&01)!=01) show_error($GLOBALS["error_msg"]["accessfunc"]);
	// Execute
	$abs = get_abs_item($dir,$item);
	if(isset($GLOBALS['__POST']["confirm"]) && $GLOBALS['__POST']["confirm"]=="true") {	
		$password=isset($GLOBALS['__POST']['pass1']);

		$id=dba_open($GLOBALS["dbfile"],"r","db4");
		if (	$id > 0)
		{ 
                        if (dba_exists($abs,$id))
                        {
				$ip=$_SERVER["REMOTE_ADDR"];
				//$ip = get_ip();
				//if (isset($_SERVER['HTTP_VIA']))
				//     $ip = $_SERVER['HTTP_CLIENT_IP'];
				//else
				//     $ip = $_SERVER['REMOTE_ADDR'] ;


				$dbline=dba_fetch($abs,$id);
				if ($pos=strpos($dbline,"/"))
				{
					list ($ipDBA,$pass2,$labelDBA) = explode ("/", $dbline);
				}
				else
				{
					$err=$GLOBALS["error_msg"]["passwordincorrect"];
				}
				if ($pos && ($pass2!= $password))
				{
					$err=$GLOBALS["error_msg"]["passwordincorrect"];
				}
				else 
				{
					// Hacemos el download
				        require "./.include/fun_down.php";
        				make_download($dir, $item);
					exit;
				}
                        }
			else $err=$GLOBALS["error_msg"]["passwordincorrect"];
                        dba_close($id);
                }
		if($err) {			// there were errors
			show_error($err);
		}
	}
		
	show_header($GLOBALS["messages"]["miscpassword"]);
	
	echo "<BR><FORM action=\"".make_link("check_password",$dir,$item);
	echo "\" method=\"post\">\n<INPUT type=\"hidden\" name=\"confirm\" value=\"true\"><TABLE>\n";
	echo "<TR><TD align=\"center\">Password: <INPUT name=\"pass1\" type=\"password\" size=\"10\"></TD></TR>\n";
	echo "</TABLE>\n<BR><TABLE><TR><TD><INPUT type=\"submit\" value=\"".$GLOBALS["messages"]["btnaccept"];
	echo "\"></TD>\n<TD><input type=\"button\" value=\"".$GLOBALS["messages"]["btncancel"];
	echo "\" onClick=\"javascript:location='".make_link("list",$dir,NULL)."';\">\n</TD></TR></FORM></TABLE><BR>\n";
	
	return;
}

function check_del_password() {		// Path absoluto del fichero a comprobar password 
	if(isset($GLOBALS['__POST']["confirm"]) && $GLOBALS['__POST']["confirm"]=="true") {	
                $cnt=count($GLOBALS['__POST']['password']);
		if ($cnt==0)
		{
			header("Location: ".make_link("list","",NULL));
		}
		$id=dba_open($GLOBALS["dbfile"],"w","db4");
		$items=$GLOBALS['__POST']['selitems'];
		$password=$GLOBALS['__POST']['password'];
		$fileswithpassword = array();
		$filesborrados = array();
		if ($id > 0)
		{ 
			$err=0;
			for($i=0;$i<$cnt;$i++) 
			{
				$errors[$i]=NULL;
				$abs=get_abs_item("",$items[$i]);
                        	if (dba_exists($abs,$id))
                        	{
					$dbline=dba_fetch($abs,$id);
					if ($pos=strpos($dbline,"/"))
					{
						list ($ipbd,$pass2,$labelDBA)=explode ("/", $dbline);
					}
					else
					{                                                
						$errors[$i]=$GLOBALS["error_msg"]["passwordincorrect"];
                                                $err=true;
					}
					if ($pos && ($pass2!= $password[$i]))
					{
						$errors[$i]=$GLOBALS["error_msg"]["passwordincorrect"];
						$err=true;
						array_push($fileswithpassword,$items[$i]);
						continue;				
					}
					else
					{
						// Borramos el fichero
				                $ok=remove($abs);
                				if($ok==false)
                				{
                        				$error[$i]=$GLOBALS["error_msg"]["delitem"];
							$fileswithpassword=array_push($items[$i]);
                        				$err=true;      continue;
                				}
                				else
                				{							
							dba_delete($abs,$id);
							loggear ("REMOVE: $items[$i]");
			                                $num=num_files($GLOBALS["home_dir"]);
                        			        $usage=dir_size($GLOBALS["home_dir"]); 
                                			$percentage=sprintf("%.2f",$usage*100/$GLOBALS["quota"]);
                                			loggear ("DISK USAGE: $num files / $usage bytes ($percentage%)"); 
                        				array_push($filesborrados,$items[$i]);
                				}
					}

				} // endif dba_exists
			} // endfor
			dba_close($id);
		}
		show_header($GLOBALS["messages"]["miscpassword"]);
        	echo "<FORM method=\"POST\" action=\"";
        	echo make_link("check_del_password",$dir,$item);
        	echo "\">\n<INPUT type=\"hidden\" name=\"confirm\" value=\"true\"><TABLE>\n";
                if($err) {                      // there were errors
                        $err_msg="";
                        for($i=0;$i<$cnt;$i++) {
                                if($errors[$i]==NULL) continue;
                                $err_msg .= $items[$i]." : ".$errors[$i]."<BR>\n";
                        }
                	echo "<TR><TD colspan=\"2\">".$GLOBALS["err_msg"]["error"]."</TD></TR>\n";
	 		echo "<TR><TD colspan=\"2\">$err_msg</TD></TR>\n";
                }        	        	
		if (count($filesborrados)>0)
        	{
                	echo "<TR><TD colspan=\"2\">".$GLOBALS["messages"]["filedeleted"]."</TD></TR>\n";
                	while (count($filesborrados)>0)
                	{
                        	$file=array_pop($filesborrados);
                        	echo "<TR><TD colspan=\"2\"><IMG SRC=\"_img/_info.gif\" align=\"ABSMIDDLE\" ALT=\"\">&nbsp;$file</TD></TR>\n";
                	}
                	echo "<TR><TD colspan=\"2\">&nbsp;</TD>\n";
        	}
		if (count($fileswithpassword)>0)
		{
        		echo "<TR><TD colspan=\"2\">".$GLOBALS["messages"]["passwordrequired"]."</TD></TR>\n";
        		while (count($fileswithpassword)>0)
        		{
                		$file=array_pop($fileswithpassword);
                		echo "<TR><TD><IMG SRC=\"_img/_info.gif\" align=\"ABSMIDDLE\" ALT=\"\">\n";
                		echo "<INPUT type=\"hidden\" name=\"selitems[]\" value=\"$file\">&nbsp;$file&nbsp;</TD>\n";
        	        	echo "<TD><INPUT type=\"password\" name=\"password[]\" size=\"20\"></TD></TR>\n";
        		}
		}
        	echo "</TABLE>\n<BR><TABLE><TR><TD><INPUT type=\"submit\" value=\"".$GLOBALS["messages"]["btnaccept"];
        	echo "\"></TD>\n<TD><input type=\"button\" value=\"".$GLOBALS["messages"]["btncancel"];
	        echo "\" onClick=\"javascript:location='".make_link("list",$dir,NULL)."';\">\n</TD></TR></TABLE></FORM>\n";
	}
	return;
}
//------------------------------------------------------------------------------
?>
